#include <hmg.ch>
#require "hbziparc"
#require "hbmzip"

Declare Window principal
Function Main
Public conectado := .f., oServer := Nil, bQuery, cQuery := "", oRow, pQuery := "", mQuery := ""
Public tColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , {193,255,193} , {255,255,255} ) } //Color Grid
Public cabezas := {'Bases de datos'}, anchos := {150}, colores := {tColor}, listadbs := {}, cabezast := {'Tablas'},cabezasl := {''}
Public workDb :="", workTable := "", listatab := {}, listaidx := {}, cuentaev := 0, cuentalos := 0
Public elnumerohoja := 0, nItemID := 1, elnumeroQuery := 0, cFile
Public elnumeroInf := 0 //El numero de la pantalla que se crea para multiples pantallas
Public nombrepantalla := {} //el nombre de la pantalla con una lista sera multidimensional para saber cuales ya estan funcionando

        Load Window Main
		main.button_1.caption := "Conectar"
        Main.Center
        Main.Activate

Return

Function laconexion()
Parameters labase
	If connect(main.text_1.Value,main.text_2.Value,main.text_3.Value,labase) = .t. 
		Return .t.
	EndIf 
Return .f.

Function tryConnection()
Local elnomloc := ""
If conectado = .t.
	disconnect()
	conectado := .f.	
	main.button_1.caption := "Conectar"
	domethod('main','tree_1','deleteallitems')
	For i:=0 To elnumeroinf -1
		elnomloc := "ConsultaInf" + AllTrim(Str(i))
		If iswindowdefined(&elnomloc)
			Release Window &elnomloc
		EndIf 
	Next
	For i:=0 To elnumeroQuery -1
		elnomloc := "CreaQuery" + AllTrim(Str(i))
		If iswindowdefined(&elnomloc)
			Release Window &elnomloc
		EndIf 
	Next
	Release Memory
	elnumeroinf := 0
Else
	If laconexion('') = .t.
		conectado := .t.
		setproperty('main','button_1','caption',"Desconectar")
		cargadb()
	Else
		MsgBox("Error al realizar la conexion","Error M101")
	EndIf
EndIf 
Return Nil

*******************************************************************************
*** Elaborada por Jorge Benavides 
*** Cargado de bases de datos en el tree
*******************************************************************************
Function cargadb()
Local xItem := ""
	If oServer = Nil
		msgstop("Necesita realizar la conexion primero","Error M102")
		Return Nil
	EndIf 
	cQuery := "show databases"
	bQuery:=oServer:Query(cQuery)  
    If bQuery:NetErr()												
        MsgStop ( bQuery:Error() )
		return Nil
    Endif
	For i:=1 To bQuery:LastRec()
	oRow := bQuery:GetRow(i)
		xItem := "database" + AllTrim(Str(i))
		DEFINE NODE AllTrim(oRow:FieldGet(1))  IMAGES Nil ID nItemID++
			AllTrim(oRow:FieldGet(1))
		End node 
	Next
    bQuery:Destroy()
disconnect()
Return Nil

*******************************************************************************
*** Elaborada por Jorge Benavides 
*** Cargado de tablas en el tree
*** o carga de informacion de la tabla en una pantalla nueva
*******************************************************************************
Function cargatablas()
	If ValType(getproperty('main','tree_1','parentvalue',getproperty('main','tree_1','Value'))) != "U"
		describetable(AllTrim(getProperty('main','tree_1','Item',main.tree_1.Value)))
		Return Nil
	EndIf 	
	workDb := getProperty('main','tree_1','Item',main.tree_1.Value)
	If laconexion(workDb) = .t.
		cQuery := "show tables from " + AllTrim(workDb)
		bQuery:=oServer:Query(cQuery)  
		If bQuery:NetErr()												
			MsgStop ( bQuery:Error() )
			return Nil
		Endif
		For i:=1 To bQuery:LastRec()
		oRow := bQuery:GetRow(i)
			main.tree_1.AddItem (AllTrim(oRow:FieldGet(1)),main.tree_1.Value,main.tree_1.Value)
		Next
		bQuery:Destroy()
	EndIf 
disconnect()
Return Nil

Function describetable(loclatabla)
	workTable := loclatabla
	cargaConsultaInf(workDb,workTable)
	disconnect()
Return Nil

Function llenagrids(frmname,locQuery)
workDb := AllTrim(getProperty('main','tree_1','Item',getproperty('main','tree_1','parentvalue',main.tree_1.Value)))
	If laconexion(workDb) = .t.
		//*---- Carga de informacion Estructura
		cQuery := "describe " + AllTrim(workTable)
		llenaGridRep(frmname,"grid_3")
		bQuery:Destroy()
		//*---- Carga de informacion Index 
		cQuery := "show index from " + AllTrim(workTable)
		llenaGridRep(frmname,"grid_4")
		bQuery:Destroy()
		//*---- Carga de informacion Opciones
		cQuery := "SELECT * FROM  INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = '" + AllTrim(workDb) + "' AND   TABLE_NAME   = '" + AllTrim(workTable) + "'" 
		llenaGridList(frmname,"grid_5") //llenaGridRep(frmname,"grid_5")
		If oRow:FieldGet("table_rows") > 0
			Setproperty(frmname,"label_15","value",AllTrim(Str(oRow:FieldGet("table_rows"))))
			setproperty(frmname,"label_16","value",Val(getproperty(frmname,"label_15","Value"))/1000)
			SetProperty(frmname,"label_4","value",alltrim(Left(getproperty(frmname,"label_16","Value"),at(".",getproperty(frmname,"label_16","Value"))-1)))
			SetProperty(frmname,"label_4","value",Val(getproperty(frmName,"label_4","Value"))+1)
			bQuery:Destroy()
			//*---- Carga inicial de informacion Datos 
			If val(getproperty(frmname,"label_4","value")) = 0
			//*---- Si hay menos de 1000 Registros
				cQuery := "select * from " + workTable
				mQuery := cQuery
			Else
			//*---- Si son mas de 1000 Registros
				cQuery := "Select * from " + workTable 
				mQuery := cQuery
				cQuery += " limit 0,1000"
			EndIf 
			llenaGridRep(frmname,"grid_1")
			SetProperty(frmname,'edit_1','Value',mQuery)
			SetProperty(frmname,"Text_2","Value","1")
		EndIf 
		bQuery:Destroy()
	Else
		msgstop("Error al Realizar la Conexion","M103")	
	EndIf 
disconnect()
Return Nil

*******************************************************************************
*** Elaborada por Jorge Benavides 
*** Llena el grid con la informacion de la consulta
*******************************************************************************
Function llenaGridRep()
Parameters locform,locgrid, locQuery
	Local miniarr := {}, newRow := ""
	If locQuery != Nil
		bQuery := oServer:Query (locQuery)
	Else
		bQuery := oServer:Query (cQuery)
	EndIf 
	If bQuery:NetErr()
		Msgstop(bQuery:Error())
		Return Nil
	EndIf
	SetProperty(locform,locgrid,"deleteallitems")
	SetProperty(locform,locgrid,"PaintDoubleBuffer",.t.)
	If getproperty(locform,locgrid,"ColumnCOUNT") = 1
		For i:=1 To bquery:fCount()-1
			_GridEx_DoMethod(locform,locgrid,"AddColumnEx",1, 'Col_', 100, Nil, Nil)
			_GridEx_SetProperty(locform,locgrid,"ColumnDYNAMICBACKCOLOR",1,tColor,Nil)			
		Next
		For i:=1 To bquery:fCount()
			_GridEx_SetProperty(locform,locgrid,"ColumnHEADER",i,bQuery:FieldName(i))
		Next 
		For i:=1 To bquery:fCount()
			encabezados := upper(bQuery:FieldName(i))
		Next
	EndIf 
	For i:=1 To bQuery:LastRec()
		oRow := bQuery:GetRow(i)
		miniarr := {}
		For g:=1 To bQuery:fCount()
			aadd(miniarr,_SQL2C(oRow:FieldGet(g)))
		Next
			_GridEx_DoMethod(locform,locgrid,"AddItemEx",miniarr)
		If cuentaev = 100
			Do Events
			Release Memory
			cuentaev := 0
		EndIf 
		cuentaev++
	Next
Return Nil

*******************************************************************************
*** Elaborada por Jorge Benavides 
*** Llena el grid con la informacion de la consulta cuando es una lista de
*** 2 columnas
*******************************************************************************
Function llenaGridList()
Parameters locform,locgrid,locQuery
	Local miniarr := {}, newRow := ""
	If locQuery != Nil
		bQuery := oServer:Query (locQuery)
	Else
		bQuery := oServer:Query (cQuery)
	EndIf 
	If bQuery:NetErr()
		Msgstop(bQuery:Error())
		Return Nil
	EndIf
	SetProperty(locform,locgrid,"deleteallitems")
	SetProperty(locform,locgrid,"PaintDoubleBuffer",.t.)
	For i:=1 To bquery:fCount()
		oRow := bQuery:GetRow(1)
		miniarr := {}
			aadd(miniarr,{upper(bQuery:FieldName(i)),_SQL2C(oRow:FieldGet(i))})
			_GridEx_DoMethod(locform,locgrid,"AddItemEx",{upper(bQuery:FieldName(i)),C2SQL(oRow:FieldGet(i))})
		If cuentaev = 100
			Do Events
			Release Memory
			cuentaev := 0
		EndIf 
		cuentaev++
	Next
Return Nil

Function cargaCreaQuery()
	If ValType(main.tree_1.parentvalue(main.tree_1.Value)) != "U"
		workDB := getproperty('main','tree_1','item',;
		getProperty('main','tree_1','parentvalue',;
		getproperty('main','tree_1','Value')))
	Else 
		workDb := getProperty('main','tree_1','item',;
		getproperty('main','tree_1','Value'))
	EndIf
	LoadCreaQuery(workDb)
Return Nil

Function aSalir()
	tryConnection()
	thiswindow.Release 
Return Nil