#include <hmg.ch>

*******************************************************************************
*** Elaborada por Rathinagiri
*******************************************************************************
Function restoredb( cZip )
   local aFiles := {}
   local cSQLFile := ''
   local cLB := chr( 10 ) + chr( 13 )
   local cTime := time()
   default cZip := ''
   
   if hmg_len( alltrim( cZip ) ) == 0
      cZip := GetFile( , 'Select the File to Restore' )
   endif
   if .not. file( cZip )   
      msgstop( cZip + ' File Not Found!' )
      return nil
   endif
   cCurFolder := GetCurrentFolder()
   cTempFolder := GetCurrentFolder() + '\' + '_RestoreTemp' + dtos( date() ) + substr( cTime, 1, 2 )  + substr( cTime, 4, 2 ) + substr( cTime, 7, 2 )
   if MakeDir( cTempFolder ) <> 0
      msgstop( 'Restore Directory could not be created!' )
      return nil
   endif   
   SetCurrentFolder( cTempFolder )
   WAIT WINDOW 'Processing the zip file...' nowait
   Uncompress File cZip
   aDirectory := Directory()
   for i := 1 to hmg_len( aDirectory )
      if HB_UTF8RAT( '.SQL', hmg_upper( aDirectory[ i, 1 ] ) ) > 0
         cSQLFile := aDirectory[ i, 1 ]
      else   
         aadd( aFiles, aDirectory[ i, 1 ] )
      endif
   next i
   if hmg_len( aFiles )== 0
      msgstop( 'Could not find any file!' )
      return nil
   endif
   if hmg_len( cSQLFile ) == 0
      msgstop( 'SQL File Not found!',"Error MyR100" )
      return nil
   endif
   cUser := getproperty('main','text_1','value')
   cHost := getproperty('main','text_2','value')
   cPass := getproperty('main','text_3','value')
   cNewDB := getproperty('main','text_4','Value')
   If laconexion(cNewDB) != .t.
		Msgstop("Error en la conexion","Error My101")
		Return Nil
   EndIf      
   bQuery := oServer:Query("show tables from " + cNewDB )
   If bQuery:NetErr()
		Msgstop(bQuery:Error(),"Error MyR 102")
		Return Nil
	EndIf
   if bQuery:LastRec() > 0
      msgstop( 'Database Should be new and empty!' )
      return nil
   EndIf 
   bQuery:Destroy()
   WAIT WINDOW 'Creating Tables...' nowait
   aCreate := HB_ATOKENS( MEMOREAD( cSQLFile ),   cLB ) 
   for i := 1 to hmg_len( aCreate )
      if hmg_len( alltrim( aCreate[ i ] ) ) > 0
         //lSuccess := .t.
		 bQuery := oServer:Query(alltrim( aCreate[ i ] ))
		 If bQuery:NetErr()
			Msgstop(bQuery:Error(),"Error MyR103")
		    Return Nil
		 EndIf
		 bQuery:Destroy()
         //lSuccess := miscsql( oDB, alltrim( aCreate[ i ] ) )
         /*if .not. lSuccess
            msgstop( 'Table Creation Error!' )
            return nil
         endif*/
      endif   
   next i
   tottables := hmg_len( aFiles )
   for i := 1 to tottables
      cFileName := aFiles[ i ]
      cTable := substr( cFileName, 1, hmg_len( cFileName ) - 4 )
      WAIT WINDOW "Processing Table - " + cTable + '( ' + alltrim( str( i ) ) + '/' + alltrim( str( tottables ) ) + ' )'   NOWAIT
      cFileNameWithPath := cTempFolder + '\' + cFileName
      cTempFileName := strtran( cFileNameWithPath, '\', '/' )
      bQuery := oServer:Query("load data infile '" + cTempFileName + "' into table " + cTable )
	  If bQuery:NetErr()
		Msgstop(bQuery:Error(),"Error MyR104")
	    Return Nil
	  EndIf
	  bQuery:Destroy()
	  /*lSuccess := miscsql( oDB, "load data infile '" + cTempFileName + "' into table " + cTable )
      if .not. lSuccess 
         msgstop( cFileName + ' could not be restored!' )
         return nil
      endif*/
   next i
   wait clear
   msginfo( 'Database restored successfully!' )
   ferase( cSQLFile )
   for i := 1 to hmg_len( aFiles )
      ferase( aFiles[ i ] )
   next i
   SetCurrentFolder( cCurFolder )
   dirremove( cTempFolder )
return nil