#include <hmg.ch>
*******************************************************************************
*** Funcion para establecer la conexion a mySql
*******************************************************************************
function connect()
Parameters mysqlsevr, mysqlusu, mysqlpass,mysqldata
   flagentramysql:=.t.
   oServer := TMySQLServer():New(mysqlsevr, mysqlusu, mysqlpass)
   If oServer:NetErr()
      MsgStop(oServer:Error())
      flagentramysql:=.f.
   else
      if !empty(mysqldata)
		oServer:SelectDB( mysqldata )
      endif
      If oServer:NetErr()
         MsgStop(oServer:Error())
         flagentramysql:=.f.
			return(flagentramysql)
      endif
      bQuery:=oServer:Query( "SET SESSION wait_timeout = 172800;")  
      If bQuery:NetErr()												
         MsgStop ( bQuery:Error() )
			return Nil
      Endif
      bQuery:Destroy()
   EndIf
return(flagentramysql)

*******************************************************************************
*** Funcion para desconectar del servidor de MySql
*******************************************************************************
function disconnect()
   if oServer != Nil                     
      oServer:Destroy()
      oServer:=Nil
   endif
return Nil

*******************************************************************************
*** Funcion para convertir la informacion a manera que sea aceptada por MySql
*******************************************************************************
function C2SQL(Value)
local cValue := "",cFormatoDaData := set(4)
   do case
      case Valtype(Value) == "N"
         cValue := AllTrim(Str(Value))
      case Valtype(Value) == "D"
         if !Empty(Value)
            cdate := dtos(value)
            cValue := "'" + substr(cDate,1,4)+"-"+substr(cDate,5,2)+"-"+substr(cDate,7,2) + "'"
         else
            cValue := "    -  -  "
         endif
      case Valtype(Value) $ "CM"
		If len(Value) = 10
			If hb_at("/",Value) = 5
				If hb_rat("/",Value,1,len(value)) = 8
					cValue := "    -  -  "
				EndIf 
			EndIf 
		EndIf 
        IF Empty( Value)
           cValue=""
        ELSE
           cValue := AllTrim(value)
        ENDIF
      case Valtype(Value) == "L"
         cValue := AllTrim(Str(iif(Value == .F., "F", "T")))
      otherwise
         cValue := "NULL"       // NOTE: Here we lose values we cannot convert
   endcase
return cValue

Function sizero()
Parameters iniValue,iniLargo
	If Valtype(iniValue) $ "CM"
			 IF Empty( iniValue)
				cValue="''"
			 ELSE
				cValue := AllTrim(iniValue)
			 ENDIF
	ElseIf Valtype(iniValue) == "N"
			 cValue := AllTrim(StrZero(iniValue,iniLargo))
	EndIf 
Return cValue

*******************************************************************************
*** Funcion para que la informacion que se muestra en el grid sea a forma de 
*** texto solo se cambio la fecha para que de esta manera se muestre 
*** correctamente en el Grid o en los archivos de CSV
*******************************************************************************
function _SQL2C(Value)
   local cValue := ""
    local cFormatoDaData := set(4)
   do case
      case Valtype(Value) == "N"
		 cValue := AllTrim(Str(Value))
      case Valtype(Value) == "D"
         if !Empty(Value)
            cdate := dtos(value)
            cValue := substr(cDate,7,2) + "/" + substr(cDate,5,2) + "/" + substr(cDate,1,4)
         else
            cValue := "  /  /    "
         endif

      case Valtype(Value) $ "CM" 
		If len(Value) = 10
			If hb_at("/",Value) = 5
				If hb_rat("/",Value,1,len(value)) = 8
					cValue := "  /  /    "
				EndIf 
			EndIf 
		EndIf 
        IF Empty( Value)
           cValue=""
        ELSE
           cValue := AllTrim(value)
        ENDIF
      case Valtype(Value) == "L"
         cValue := AllTrim(Str(iif(Value == .F., "F", "T")))
      otherwise
         cValue := "NULL"       // NOTE: Here we lose values we cannot convert
   endcase
return cValue