#include <hmg.ch>
*******************************************************************************
*** Elaborada por Jorge Benavides 
*** Function imprimexls -- GRID --
*** Parameters
***		windowname			el nombre de la forma que contiene el grid
***
***		gridname			el nombre del grid que se quiere imprimir
***
***		repotitle			El ttulo del Reporte como aparecer en Excel
***
***		papers				el tamao del papel 1 es carta 5 oficio
***
***		orient				La orientacin del papel &&'xlLandscape' 1 && 
***								'xlPortrait' 2
***
***		autoalign			Para que todas las columnas tengan el mismo ancho 
***								1 para si 2 para no
*******************************************************************************
Function imprimexls()
Parameters windowname,gridname,repotitle,papers,orient,autoalign
Private nRow:=1, oSheet, oExcel, aprompt:={}, afldnm:={}
Private tituloimp:="", ColumnasImp:={}, NoColImp:=""
	_iniciaexcel()
	_llenainfo()
	_terminaexcel(autoalign)
Return Nil

Function _llenainfo()
	Local elobjeto:="",therecs:=0,theitem:=""
	therecs := getProperty(windowname,gridname,'itemcount')
	For i:=1 To therecs 
		For g:=1 To getproperty(windowname,gridname,'columncount')
			theitem := getProperty(windowname,gridname,'cellex',i,g)
			oSheet:Cells(nRow,g):Value := AllTrim(theitem)
		Next
		nRow++
	Next
Return Nil

*****************************************************************
***
***			Inicializacin del archivo de Excel
***			se crean los ttulos de columna
***			Por Jorge Benavides  -- GRID --
***	Actualizada el 01/08/2018
*****************************************************************
Function _iniciaexcel()
//	Declare Window &windowname
	Wait Window "Creating Excel File Please Wait ! . . ." NOWait    // ini wait window
   oExcel = CREATEObject( "Excel.Application" ) // create object

   oExcel:WorkBooks:Add() // create book
   oSheet = oExcel:ActiveSheet // create sheet
	oExcel:ActiveSheet:PageSetup:PaperSize:= iif(papers>0,papers,1) //Paper size
	With Object oSheet:PageSetup
		:Orientation := iif(orient>0,orient,1) //&&'xlLandscape' 1 && 'xlPortrait' 2
	End
   nRow++ //let to rows at the begining of file
   nRow++ // to use later
	With Object oSheet
	   For _i := 1 To getproperty(windowname,gridname,'columncount')
			 :Cells(nRow, _i):Value = getproperty(windowname,gridname,'columnHeader',_i)
	   Next
	End
	nRow++
Return Nil

*****************************************************************
***
***			Terminacin del archivo de Excel
***			se aplica la configuracin del archivo
***			Por Jorge Benavides    -- GRID --
***	Actualizada el 01/08/2018
*****************************************************************
Function _terminaexcel()
Parameters autoalign
	Local ActRow:=0, ini := 0, letraini := 0

	nRow++
	nRow++
	
	letraini := convertToTitle(getproperty(windowname,gridname,'columnCount'))

	If repotitle <> NIL
	NoColImp1 := "A1:" + letraini + "1"
		 oSheet:Range(NoColImp1):Merge()
		 oSheet:Cells(1,1):Font:Size := 12
		 oSheet:Cells( 1, 1 ):Value := repotitle
	EndIf
	oSheet:Range("A1"):Select()
	nRow++
	NoColImp1 := "A1:" + letraini + "1"
	If autoalign = 1
		oSheet:Columns("A:" + letraini):AuToFit()
	EndIf 
	For i=1 To getproperty(windowname,gridname,'columncount')
		oSheet:Cells( 3, i ):Font:Bold := .T.
	Next
	oSheet:PageSetup:PrintTitleRows = "$1:$3"
	oExcel:Visible = .T.
	Wait Clear
Return Nil

*****************************************************************
*** 
*** https://helloacm.com/cc-coding-exercise-excel-sheet-column-number-and-title-conversion/
***
***			Convertida de C++ a Harbour
***			Por Jorge Benavides
***	Agregada el 01/08/2016
*****************************************************************
Function convertToTitle(n)
Local r := ""
	while (n >= 0)
		r := chr(65 + (n - 1) % 26) + r
		n := (n - 1) / 26
	End
	r := Right(r,len(r)-1)
Return r

*******************************************************************************
*** Elaborada por Jorge Benavides 
*** Function imprimeXlsQuery -- MySql Query --
*** Parameters
***
***		locQuery			El nombre de la variable que contiene el Query
***
***		locWorkdb			El nombre de la base de datos
***
***		repotitle			El ttulo del Reporte como aparecer en Excel
***
***		papers				el tamao del papel 1 es carta 5 oficio
***
***		orient				La orientacin del papel &&'xlLandscape' 1 && 
***								'xlPortrait' 2
***
***		autoalign			Para que todas las columnas tengan el mismo ancho 
***								1 para si 2 para no
*******************************************************************************
Function imprimeXlsQuery()
Parameters locQuery,locWorkdb,repotitle,papers,orient,autoalign
Private nRow:=1, oSheet, oExcel, aprompt:={}, afldnm:={}
Private tituloimp:="", ColumnasImp:={}, NoColImp:="", nQuery
	disconnect()
	If laconexion(locWorkdb) != .t.
		MsgBox("Error al Realizar la conexion","Error C102")
		Return Nil
	EndIf
	nQuery := oServer:Query(locQuery)
	_iniciaexcelQuery()
	_llenainfoQuery()
	_terminaexcelQuery(autoalign)
Return Nil

Function _llenainfoQuery()
	Local elobjeto:="",theitem:=""
	For i:=1 To nQuery:LastRec()
		oRow := nQuery:GetRow(i)
		For g:=1 To nQuery:FCount()
			theitem := oRow:FieldGet(g)
			oSheet:Cells(nRow,g):Value := C2SQL(theitem)
		Next
		nRow++
	Next
Return Nil

*****************************************************************
***
***			Inicializacin del archivo de Excel
***			se crean los ttulos de columna
***			Por Jorge Benavides  -- MySql Query --
***	
*****************************************************************
Function _iniciaExcelQuery()
	Wait Window "Creating Excel File Please Wait ! . . ." NOWait    // ini wait window
   oExcel = CREATEObject( "Excel.Application" ) // create object

   oExcel:WorkBooks:Add() // create book
   oSheet = oExcel:ActiveSheet // create sheet
	oExcel:ActiveSheet:PageSetup:PaperSize:= iif(papers>0,papers,1) //Paper size
	With Object oSheet:PageSetup
		:Orientation := iif(orient>0,orient,1) //&&'xlLandscape' 1 && 'xlPortrait' 2
	End
   nRow++ //let to rows at the begining of file
   nRow++ // to use later
	With Object oSheet
	   For _i := 1 To nQuery:FCount()
	   oRow := nQuery:GetRow(_i)
			 :Cells(nRow, _i):Value = oRow:FieldName(_i)
	   Next
	End
	nRow++
Return Nil

*****************************************************************
***
***			Terminacin del archivo de Excel
***			se aplica la configuracin del archivo
***			Por Jorge Benavides -- MySql Query --
***	
*****************************************************************
Function _terminaExcelQuery()
Parameters autoalign
	Local ActRow:=0, ini := 0, letraini := 0

	nRow++
	nRow++
	
	letraini := convertToTitle(nQuery:FCount())

	If repotitle <> NIL
	NoColImp1 := "A1:" + letraini + "1"
		 oSheet:Range(NoColImp1):Merge()
		 oSheet:Cells(1,1):Font:Size := 12
		 oSheet:Cells( 1, 1 ):Value := repotitle
	EndIf
	oSheet:Range("A1"):Select()
	nRow++
	NoColImp1 := "A1:" + letraini + "1"
	If autoalign = 1
		oSheet:Columns("A:" + letraini):AuToFit()
	EndIf 
	For i=1 To nQuery:FCount()
		oSheet:Cells( 3, i ):Font:Bold := .T.
	Next
	oSheet:PageSetup:PrintTitleRows = "$1:$3"
	oExcel:Visible = .T.
	Wait Clear
Return Nil

